/*********************************************************************
Copyright 1992 by Digital Press/Digital Equipment Corporation, Elias
Israel, and Erik Fortune

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.  Digital Equipment Corporation and the
authors make no representations about the suitability of this software
for any purpose.  It is provided "as is" without express or implied
warranty.

DIGITAL EQUIPMENT CORPORATION AND THE AUTHORS DISCLAIM ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL EQUIPMENT
CORPORATION OR THE AUTHORS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

This material is reproduced with permission from _The X Window System
Server: X Version 11, Release 5_, by Elias Israel and Erik Fortune.
(Copyright 1992, Digital Press, Digital Equipment Corporation, One
Burlington Woods Drive, Burlington, MA 01803)
*********************************************************************/

#include <scrnintstr.h>
#include "ddxScreens.h"

Bool
ddxCursorOffScreen(ppScreen, pX, pY)
ScreenPtr	*ppScreen;
int		*pX, *pY;
{
int	x= *pX;
int	y= *pY;
ScreenPtr	pScreen = *ppScreen;
ScreenPtr	pNewScreen = NULL;

    /*
     * TBD (FOURTH STAGE)
     *    The MI pointer implementation calls this routine whenever the pointer
     * travels outside of the screen boundaries.   If you support multiple 
     * screens, this routine should choose a new screen and new coordinates 
     * for the pointer and return them in *ppScreen, *pX and *pY.   This 
     * sample implementation arranges screens in a *very* simple horizontal 
     * array with screen 0 on the left.   You might wish to allow for more
     * elaborate setups.
     */
    if ((x<0)&&(pScreen->myNum>0)) {
	 pNewScreen = screenInfo.screens[pScreen->myNum-1];
	 x = pNewScreen->width+x;
    }
    else if ((x>pScreen->width)&&(pScreen->myNum<screenInfo.numScreens-1)) {
	 pNewScreen = screenInfo.screens[pScreen->myNum+1];
	 x = x - pScreen->width;
    }
    else {
	return FALSE;
    }

    if ( pScreen->height != pNewScreen->height )
	y = ( y * pNewScreen->height ) / pScreen->height;
    *pX = x;
    *pY = y;
    *ppScreen = pScreen;
    return TRUE;
}

    /*
     * DO NOT CHANGE ANYTHING BELOW HERE
     *   The newdev script relies on the comments in this file 
     * to correctly insert new displays into the list of known
     * devices.  Define the EXCLUDE* macros in your Imakefile
     * if you wish to leave some device out.
     */

int		ddxMaxScreens=		1;

int		nRequestedScreens=	0;
ddxScreenReq	requestedScreens[MAXSCREENS];

/* DEVICE_EXTERN */

ddxScreenDesc	*pKnownScreens[] = {
	/* DEVICE_DESC */
	NULL
};

int	nKnownScreens=	(sizeof(pKnownScreens)/sizeof(ddxScreenDesc *))-1;

