#ifndef GEN_KEYMAP
#define GEN_KEYMAP 1

#define	GEN_GLYPHS_PER_KEY	2
#define	GEN_MIN_KEY		8
#define	GEN_MAX_KEY		110
#define	GEN_NUM_KEYS		(GEN_MAX_KEY-GEN_MIN_KEY)

static KeySym genKeymap[MAP_LENGTH*GEN_GLYPHS_PER_KEY] = {
/* Scan Code */	/* X11 Keysym(s) */		/* Key */
/*   8 */    	XK_Escape,	XK_Escape,
/*   9 */    	XK_1,		XK_exclam,	
/*  10 */    	XK_2,		XK_at,	
/*  11 */    	XK_3,		XK_numbersign,	
/*  12 */    	XK_4,		XK_dollar,	
/*  13 */   	XK_5,		XK_percent,	
/*  14 */   	XK_6,		XK_asciicircum,	
/*  15 */   	XK_7,		XK_ampersand,	
/*  16 */   	XK_8,		XK_asterisk,	
/*  17 */   	XK_9,		XK_parenleft,	
/*  18 */   	XK_0,		XK_parenright,	
/*  19 */   	XK_minus,	XK_underscore,	
/*  20 */   	XK_equal,	XK_plus,	
/*  21 */   	XK_BackSpace,	XK_BackSpace,
/*  22 */   	XK_Tab,		NoSymbol,
/*  23 */   	XK_q,		XK_Q,
/*  24 */   	XK_w,		XK_W,
/*  25 */   	XK_e,		XK_E,
/*  26 */   	XK_r,		XK_R,
/*  27 */   	XK_t,		XK_T,
/*  28 */   	XK_y,		XK_Y,
/*  29 */   	XK_u,		XK_U,
/*  30 */   	XK_i,		XK_I,
/*  31 */   	XK_o,		XK_O,
/*  32 */   	XK_p,		XK_P,
/*  33 */   	XK_bracketleft,	XK_braceleft,	
/*  34 */   	XK_bracketright,XK_braceright,	
/*  35 */   	XK_Return,	XK_Return,
/*  36 */   	XK_Control_L,	XK_Control_L,
/*  37 */   	XK_a,		XK_A,
/*  38 */   	XK_s,		XK_S,
/*  39 */   	XK_d,		XK_D,
/*  40 */   	XK_f,		XK_F,
/*  41 */   	XK_g,		XK_G,
/*  42 */   	XK_h,		XK_H,
/*  43 */   	XK_j,		XK_J,
/*  44 */   	XK_k,		XK_K,
/*  45 */   	XK_l,		XK_L,
/*  46 */   	XK_semicolon,	XK_colon,
/*  47 */   	XK_quoteright,	XK_quotedbl,
/*  48 */   	XK_quoteleft,	XK_asciitilde,
/*  49 */   	XK_Shift_L,	XK_Shift_L,
/*  50 */   	XK_backslash,	XK_bar,
/*  51 */   	XK_z,		XK_Z,
/*  52 */   	XK_x,		XK_X,
/*  53 */   	XK_c,		XK_C,
/*  54 */   	XK_v,		XK_V,
/*  55 */   	XK_b,		XK_B,
/*  56 */   	XK_n,		XK_N,
/*  57 */   	XK_m,		XK_M,
/*  58 */   	XK_comma,	XK_less,	
/*  59 */   	XK_period,	XK_greater,	
/*  60 */   	XK_slash,	XK_question,	
/*  61 */   	XK_Shift_R,	XK_Shift_R,
/*  62 */   	XK_KP_Multiply,	XK_Print,
/*  63 */   	XK_Alt_L,	XK_Alt_L,
/*  64 */   	XK_space,	XK_space,
/*  65 */   	XK_Caps_Lock,	XK_Caps_Lock,
/*  66 */   	XK_F1,		XK_F13,
/*  67 */   	XK_F2,		XK_F14,
/*  68 */   	XK_F3,		XK_F15,
/*  69 */   	XK_F4,		XK_F16,
/*  70 */   	XK_F5,		XK_F17,
/*  71 */   	XK_F6,		XK_F18,
/*  72 */   	XK_F7,		XK_F19,
/*  73 */   	XK_F8,		XK_F20,
/*  74 */   	XK_F9,		XK_F21,
/*  75 */   	XK_F10,		XK_F16,
/*  76 */   	XK_Num_Lock,	XK_Num_Lock,
/*  77 */   	XK_Pause,	XK_Pause,
/*  78 */   	XK_Home,	XK_KP_7,	
/*  79 */   	XK_Up,		XK_KP_8,	
/*  80 */   	XK_Prior,	XK_KP_9,	
/*  81 */   	XK_KP_Subtract,	XK_KP_Subtract,
/*  82 */   	XK_Left,	XK_KP_4,	
/*  83 */   	XK_Home,	XK_KP_5,	
/*  84 */   	XK_Right,	XK_KP_6,	
/*  85 */   	XK_KP_Add,	XK_KP_Add,
/*  86 */   	XK_End,		XK_KP_1,	
/*  87 */   	XK_Down,	XK_KP_2,	
/*  88 */   	XK_Next,	XK_KP_3,	
/*  89 */   	XK_Insert,	XK_KP_0,	
/*  90 */   	XK_Delete,	XK_KP_Decimal,	
/*  91 */   	XK_Select,	XK_Select,
/*  92 */   	NoSymbol,	NoSymbol,
/*  93 */   	NoSymbol,	NoSymbol,
/*  94 */   	XK_F11,		XK_F23,
/*  95 */   	XK_F12,		XK_F24,
/*  96 */   	NoSymbol,	NoSymbol,
/*  97 */   	XK_Insert,	XK_Insert,
/*  98 */   	XK_Home,	XK_Home,
/*  99 */   	XK_Prior,	XK_Prior,
/* 100 */   	XK_Delete,	XK_Delete,
/* 101 */   	XK_End,		XK_End,
/* 102 */   	XK_Next,	XK_Next,
/* 103 */   	XK_Left,	XK_Left,
/* 104 */   	XK_Up,		XK_Up,
/* 105 */   	XK_Down,	XK_Down,
/* 106 */   	XK_Right,	XK_Right,
/* 107 */   	XK_KP_Enter,	XK_KP_Enter,
/* 108 */   	XK_Control_R,	XK_Control_R,
/* 109 */   	XK_Alt_R,	XK_Alt_R,
/* 110 */  	XK_KP_Divide,	XK_KP_Divide,
};
#endif /* ndef GENKEYMAP_H */
