/*********************************************************************
Copyright 1992 by Digital Press/Digital Equipment Corporation, Elias
Israel, and Erik Fortune

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.  Digital Equipment Corporation and the
authors make no representations about the suitability of this software
for any purpose.  It is provided "as is" without express or implied
warranty.

DIGITAL EQUIPMENT CORPORATION AND THE AUTHORS DISCLAIM ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL EQUIPMENT
CORPORATION OR THE AUTHORS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

This material is reproduced with permission from _The X Window System
Server: X Version 11, Release 5_, by Elias Israel and Erik Fortune.
(Copyright 1992, Digital Press, Digital Equipment Corporation, One
Burlington Woods Drive, Burlington, MA 01803)
*********************************************************************/

#define	NEED_EVENTS
#include <X11/X.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include "misc.h"
#include "inputstr.h"

	/*
	 * TBD (THIRD STAGE)
	 * This keysym table is for an IBM PC/XT keyboard.
	 * Some systems use the same scan codes as the PC/XT,
	 * but many don't.   If your system uses different 
	 * scan codes, you will have to replace this table.
	 * Consult the documentation for your system to find
	 * the correct entries.
	 */

#define	XOS_GLYPHS_PER_KEY	2
#define	XOS_MIN_KEY		7
#define	XOS_MAX_KEY		110
#define	XOS_NUM_KEYS		(XOS_MAX_KEY-XOS_MIN_KEY+1)

static KeySym xosKeymap[MAP_LENGTH*XOS_GLYPHS_PER_KEY] = {
/* Scan Code */	/* X11 Keysym(s) */		/* Key */
/*   7 */       NoSymbol,	NoSymbol,
/*   8 */    	XK_Escape,	XK_Escape,
/*   9 */    	XK_1,		XK_exclam,	
/*  10 */    	XK_2,		XK_at,	
/*  11 */    	XK_3,		XK_numbersign,	
/*  12 */    	XK_4,		XK_dollar,	
/*  13 */   	XK_5,		XK_percent,	
/*  14 */   	XK_6,		XK_asciicircum,	
/*  15 */   	XK_7,		XK_ampersand,	
/*  16 */   	XK_8,		XK_asterisk,	
/*  17 */   	XK_9,		XK_parenleft,	
/*  18 */   	XK_0,		XK_parenright,	
/*  19 */   	XK_minus,	XK_underscore,	
/*  20 */   	XK_equal,	XK_plus,	
/*  21 */   	XK_BackSpace,	XK_BackSpace,
/*  22 */   	XK_Tab,		NoSymbol,
/*  23 */   	XK_Q,		NoSymbol,
/*  24 */   	XK_W,		NoSymbol,
/*  25 */   	XK_E,		NoSymbol,
/*  26 */   	XK_R,		NoSymbol,
/*  27 */   	XK_T,		NoSymbol,
/*  28 */   	XK_Y,		NoSymbol,
/*  29 */   	XK_U,		NoSymbol,
/*  30 */   	XK_I,		NoSymbol,
/*  31 */   	XK_O,		NoSymbol,
/*  32 */   	XK_P,		NoSymbol,
/*  33 */   	XK_bracketleft,	XK_braceleft,	
/*  34 */   	XK_bracketright,XK_braceright,	
/*  35 */   	XK_Return,	XK_Return,
/*  36 */   	XK_Control_L,	XK_Control_L,
/*  37 */   	XK_A,		NoSymbol,
/*  38 */   	XK_S,		NoSymbol,
/*  39 */   	XK_D,		NoSymbol,
/*  40 */   	XK_F,		NoSymbol,
/*  41 */   	XK_G,		NoSymbol,
/*  42 */   	XK_H,		NoSymbol,
/*  43 */   	XK_J,		NoSymbol,
/*  44 */   	XK_K,		NoSymbol,
/*  45 */   	XK_L,		NoSymbol,
/*  46 */   	XK_semicolon,	XK_colon,
/*  47 */   	XK_quoteright,	XK_quotedbl,
/*  48 */   	XK_quoteleft,	XK_asciitilde,
/*  49 */   	XK_Shift_L,	XK_Shift_L,
/*  50 */   	XK_backslash,	XK_bar,
/*  51 */   	XK_Z,		NoSymbol,
/*  52 */   	XK_X,		NoSymbol,
/*  53 */   	XK_C,		NoSymbol,
/*  54 */   	XK_V,		NoSymbol,
/*  55 */   	XK_B,		NoSymbol,
/*  56 */   	XK_N,		NoSymbol,
/*  57 */   	XK_M,		NoSymbol,
/*  58 */   	XK_comma,	XK_less,	
/*  59 */   	XK_period,	XK_greater,	
/*  60 */   	XK_slash,	XK_question,	
/*  61 */   	XK_Shift_R,	XK_Shift_R,
/*  62 */   	XK_KP_Multiply,	XK_Print,
/*  63 */   	XK_Alt_L,	XK_Alt_L,
/*  64 */   	XK_space,	XK_space,
/*  65 */   	XK_Caps_Lock,	XK_Caps_Lock,
/*  66 */   	XK_F1,		XK_F13,
/*  67 */   	XK_F2,		XK_F14,
/*  68 */   	XK_F3,		XK_F15,
/*  69 */   	XK_F4,		XK_F16,
/*  70 */   	XK_F5,		XK_F17,
/*  71 */   	XK_F6,		XK_F18,
/*  72 */   	XK_F7,		XK_F19,
/*  73 */   	XK_F8,		XK_F20,
/*  74 */   	XK_F9,		XK_F21,
/*  75 */   	XK_F10,		XK_F16,
/*  76 */   	XK_Num_Lock,	XK_Num_Lock,
/*  77 */   	XK_Pause,	XK_Pause,
/*  78 */   	XK_Home,	XK_KP_7,	
/*  79 */   	XK_Up,		XK_KP_8,	
/*  80 */   	XK_Prior,	XK_KP_9,	
/*  81 */   	XK_KP_Subtract,	XK_KP_Subtract,
/*  82 */   	XK_Left,	XK_KP_4,	
/*  83 */   	XK_Home,	XK_KP_5,	
/*  84 */   	XK_Right,	XK_KP_6,	
/*  85 */   	XK_KP_Add,	XK_KP_Add,
/*  86 */   	XK_End,		XK_KP_1,	
/*  87 */   	XK_Down,	XK_KP_2,	
/*  88 */   	XK_Next,	XK_KP_3,	
/*  89 */   	XK_Insert,	XK_KP_0,	
/*  90 */   	XK_Delete,	XK_KP_Decimal,	
/*  91 */   	XK_Select,	XK_Select,
/*  92 */   	NoSymbol,	NoSymbol,
/*  93 */   	NoSymbol,	NoSymbol,
/*  94 */   	XK_F11,		XK_F23,
/*  95 */   	XK_F12,		XK_F24,
/*  96 */   	NoSymbol,	NoSymbol,
/*  97 */   	XK_Insert,	XK_Insert,
/*  98 */   	XK_Home,	XK_Home,
/*  99 */   	XK_Prior,	XK_Prior,
/* 100 */   	XK_Delete,	XK_Delete,
/* 101 */   	XK_End,		XK_End,
/* 102 */   	XK_Next,	XK_Next,
/* 103 */   	XK_Left,	XK_Left,
/* 104 */   	XK_Up,		XK_Up,
/* 105 */   	XK_Down,	XK_Down,
/* 106 */   	XK_Right,	XK_Right,
/* 107 */   	XK_KP_Enter,	XK_KP_Enter,
/* 108 */   	XK_Control_R,	XK_Control_R,
/* 109 */   	XK_Alt_R,	XK_Alt_R,
/* 110 */  	XK_KP_Divide,	XK_KP_Divide,
};

void
xosBell(volume, pDev)
int		volume;
DeviceIntPtr	pDev;
{
    /*
     * TBD (FOURTH STAGE)
     * Add code here to ring the device bell.
     */
    return;
}

void
xosChangeKeyboardControl(pDev,ctrl)
DeviceIntPtr	pDev;
KeybdCtrl	*ctrl;
{
    /*
     * TBD (FOURTH STAGE)
     *    Add code here to change key click and autorepeat.
     */
    return;
}

Bool
LegalModifier( key, pDev )
BYTE	  key;
DevicePtr pDev;
{
   /*
    *    The DIX layer calls this routine to find out if a key may be
    * used as a modifier.   Most systems allow any key to be used as
    * a modifier, so this function simply returns TRUE.
    */
    return TRUE;
}

    /*
     * This function examines a list of KeySyms and determines
     * its modifier map.  You should not have to modify this
     * function unless you want to change the set of keys that
     * generate some modifier.
     */

static void
xosGetKbdMappings( pKeySyms, pModMap )
KeySymsPtr	 pKeySyms;
CARD8		*pModMap;
{
register int key,sym;

    for (key= MAP_LENGTH; key-- ; )
	pModMap[key]= NoSymbol;	/* make sure it is restored */

    /* examine first KeySym on each key for modifier key cap */
    for (sym=0,key=XOS_MIN_KEY;
		key<=XOS_MAX_KEY;
		key++,sym+=XOS_GLYPHS_PER_KEY) {
	switch (xosKeymap[sym]) {
	    case XK_Shift_L:	case XK_Shift_R:
		pModMap[key]=	ShiftMask;
		break;
	    case XK_Control_L:	case XK_Control_R:
		pModMap[key]=	ControlMask;
		break;
	    case XK_Caps_Lock:	case XK_Num_Lock:
		pModMap[key]=	LockMask;
		break;
	    case XK_Alt_L:	case XK_Alt_R:
		pModMap[key]=	Mod1Mask;
		break;
	    case XK_Super_L:	case XK_Super_R:
		pModMap[key]=	Mod2Mask;
		break;
	    case XK_Hyper_L:	case XK_Hyper_R:
		pModMap[key]=	Mod3Mask;
		break;
	    default:
		pModMap[key]=	NoSymbol;
		break;
	}
    }

    pKeySyms->minKeyCode =	XOS_MIN_KEY;
    pKeySyms->maxKeyCode =	XOS_MAX_KEY;
    pKeySyms->mapWidth =	XOS_GLYPHS_PER_KEY;
    pKeySyms->map =		xosKeymap;
    return ;
}

int
xosKeyboardProc(pKeyboard, what, argc, argv)
DevicePtr	pKeyboard;
int		what;
int		argc;
char		*argv[];
{
KeySymsRec	keySyms;
CARD8		modMap[MAP_LENGTH];

    switch (what) {
	case DEVICE_INIT: 
	    /* 
	     * TBD (THIRD STAGE) 
	     *    At this stage, we're only setting up the device. It shouldn't
             * report events yet.   If you need to probe for the existence of
	     * a pointer or initialize some driver or data structures, this is
	     * the place to do it.   You can store anything you want in
	     * pPtr->devicePrivate (of type pointer).
	     */
	    xosGetKbdMappings( &keySyms, modMap );
	    InitKeyboardDeviceStruct(pKeyboard, &keySyms, modMap, xosBell,
						xosChangeKeyboardControl);
	    break;
	case DEVICE_ON: 
	    /*
	     * TBD (THIRD STAGE)
	     *    The DIX layer is ready to get events from the device.  Open
	     * the device here or allow it to generate events.
	     */
	     break;
	case DEVICE_OFF: 
            /*
	     * TBD (THIRD STAGE)
	     *    The DIX layer no longer wants events from the device.  
	     * Suspend or close it.
	     */
	     break;
	case DEVICE_CLOSE:
            /*
	     * TBD (THIRD STAGE)
	     *    The DIX layer is about to free this device.   Close it down
	     * for good and free any private data structures.  If you stored
	     * anything in pPtr->devicePrivate, you should free it here.
	     */
	     break;
    }
    return Success;
}

