/*********************************************************************
Copyright 1992 by Digital Press/Digital Equipment Corporation, Elias
Israel, and Erik Fortune

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.  Digital Equipment Corporation and the
authors make no representations about the suitability of this software
for any purpose.  It is provided "as is" without express or implied
warranty.

DIGITAL EQUIPMENT CORPORATION AND THE AUTHORS DISCLAIM ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL EQUIPMENT
CORPORATION OR THE AUTHORS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

This material is reproduced with permission from _The X Window System
Server: X Version 11, Release 5_, by Elias Israel and Erik Fortune.
(Copyright 1992, Digital Press, Digital Equipment Corporation, One
Burlington Woods Drive, Burlington, MA 01803)
*********************************************************************/

#ifndef XXXDEVINT_H
#define XXXDEVINT_H 1

#include "xxxDev.h"

   /*\
    *    This file defines a number of macros which describe your
    * device and which the other files in this directory use 
    * to set your device up correctly.  It also defines the screen 
    * private data structure used by this directory.   Initially
    * the data structure includes only the common fields defined 
    * by ddxScreens.h.   As you discover display-private information
    * (such as the file descriptor, base address, or initial state of 
    *  your display device) you can add fields to the xxxScreenPrivRec
    * definition at the end of this file.   Don't forget to modify
    * xxxScreenInit to initialize the new fields!
    *
    *    If you used the "newddx" or "newdev" script to generate
    * this file, it should be correct.   If you are copying the
    * file manually, search for macros which contain "SOME" and
    * replace them with the appropriate value.  For example,
    * change XXX_IS_SOME_TYPE with:
    *   XXX_IS_MFB -- for devices with a one bit deep, accessible
    *                 framebuffer.
    *   XXX_IS_CFB -- for devices with an eight bit deep, Z-format,
    *                 accessible framebuffer.
    * replace all occurences of SOME_WIDTH with the width of your
    * screen in pixels and so forth.
    */

#define	XXX_IS_SOME_TYPE

#if defined(XXX_IS_MFB) || defined(XXX_IS_XY)
#define	XXX_SCREEN_INIT		mfbScreenInit
#define	XXX_CREATE_DEF_COLORMAP	mfbCreateDefColormap
#define	XXX_BITS_PER_PIXEL	SOME_BITS_PER_PIXEL
#define	XXX_DEPTH		SOME_DEPTH
#endif

#ifdef XXX_IS_CFB
#define	XXX_SCREEN_INIT		cfbScreenInit
#define	XXX_CREATE_DEF_COLORMAP	cfbCreateDefColormap
#define	XXX_BITS_PER_PIXEL	SOME_BITS_PER_PIXEL
#define	XXX_DEPTH		SOME_DEPTH
#endif

#define	XXX_SCREEN_WIDTH	SOME_WIDTH
#define	XXX_SCREEN_HEIGHT	SOME_HEIGHT
#define	XXX_X_RESOLUTION	SOME_X_RES
#define	XXX_Y_RESOLUTION	SOME_Y_RES
#define	XXX_BUFFER_WIDTH	SOME_BUFFER_WIDTH

#define	XXX_BLACK_PIXEL		SOME_BLACK_PIXEL
#define	XXX_WHITE_PIXEL		SOME_WHITE_PIXEL

#ifdef _NEED_XXX_PRIVATE
typedef struct _xxxScreenPrivRec {
	ddxScreenPriv	common;
	Bool		(*CloseScreen)( /* index,  pScreen */ );
	ColormapPtr	pInstalledCMap;
	/* add display specific private fields here */
} xxxScreenPrivRec, *xxxScreenPrivPtr;

#define	xxxPriv(s) ((xxxScreenPrivPtr)(s)->devPrivates[ddxScreenPrivIndex].ptr)

#endif /* _NEED_XXX_PRIVATE */
#endif /* XXXDEVINT_H */
