:

# Copyright 1992 by Digital Press/Digital Equipment Corporation, Elias
# Israel, and Erik Fortune
# 
# Permission to use, copy, modify, distribute, and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation.  Digital Equipment Corporation and the
# authors make no representations about the suitability of this software
# for any purpose.  It is provided "as is" without express or implied
# warranty.
# 
# DIGITAL EQUIPMENT CORPORATION AND THE AUTHORS DISCLAIM ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL EQUIPMENT
# CORPORATION OR THE AUTHORS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
# USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
# 
# This material is reproduced with permission from _The X Window System
# Server: X Version 11, Release 5_, by Elias Israel and Erik Fortune.
# (Copyright 1992, Digital Press, Digital Equipment Corporation, One
# Burlington Woods Drive, Burlington, MA 01803)


#
# script to generate a Makefile from an Imakefile.  Sometimes useful for 
# generating Makefiles for stuff outside the X sources.
# 

progname=$0
xtop=$1
what=$2

if [ x"$xtop" = x ]; then
    echo "usage:  $progname  xsrctop  [whattomake]"
    exit 1
fi

if [ x"$what" = x ]; then
    what="Makefile"
fi

if [ ! -d $xtop ]; then
    echo "$progname"":  no such directory $xtop"
    exit 1
fi

if [ ! -d $xtop/config ]; then
    echo "$progname"":  no X configuration files under $xtop"
    exit 1
fi

if [ ! -f Imakefile ]; then
    echo "$progname"":  can't find `pwd`/Imakefile"
    exit 1
fi

if [ -f $what ]; then
	rm -f ${what}.bak
	mv $what ${what}.bak
fi

echo "Making $what from Imakefile"
PATH=$xtop/util/imake:$PATH \
imake -DTOPDIR=$xtop -I$xtop/config $what
